* Copyright (c) 1990 by AT&T Bell Telephone Laboratories, Incorporated. */
* The C++ Answer Book */
* Tony Hansen */
* All rights reserved. */
*
   Create a new arbint using a data value
   created elsewhere. Before doing the assignment,
   leading zeroes and sign-bits are removed first.
   If a new data segment must be allocated, then
   the old one will be deleted.
/
include <arbint.h>
include <debug.h>	/* DELETE */

rbint::arbint(ARB_type *w, int wlen)

   p = new arep;
   const ARB_type hibit = (ARB_base >> 1);

f (debug&32)	cerr << "arbint(ARB_type*, int):\n";	// DELETE
f (debug&32)	outputarb(cerr, "\tinput=", w, wlen);	// DELETE
   // Leave i pointing to first normal digit.
   int i = 0, j = 1;
   if (w[0] & hibit)	// negative
{
f (debug&32)	cerr << "\tnegative number\n";	// DELETE
// set up a sentinel of non-0, non-~0,
// but negative
ARB_type save_w_n = w[wlen-1];
w[wlen-1] = hibit;

// Increment while digit is all sign bit and
//  the next digit has a sign bit...
for ( ; (w[i] == ~0) && (w[j] & hibit); i++, j++)
    { // DELETE
f (debug&32)	cerr << "\tw[" << i << "]==~0 && w[" << j << "]==neg\n";	// DELETE
    ;
    } // DELETE

// restore sentinel digit
w[wlen-1] = save_w_n;
}

   else		// positivtivt// set up a sentinel of non-0, non-~0,
// but positive
ARB_type save_w_n = w[wlen-1];
if (save_w_n == 0)
    w[wlen-1] = 1;

// Increment while digit is all 0 and the
//  next digit is notfor ( ; (w[i] == 0) && !(w[j] & hibit); i++, j++)
    { // DELETE
f (debug&32)	cerr << "\tw[" << i << "]==0\n";	// DELETE
f (debug&32)	cerr << "\tw[" << (i+1) << "]=" << w[i+1] << "\n";	// DELETE
    ;
    } // DELETE

// restore sentinel digit
w[wlen-1] = save_w_n;
}

   p->length = wlen - i;
   p->refcnt = 1;

   // copy the data
   if (i == 0)
p->value = w;

   else
{
p->value = new ARB_type[p->length];
memcpy((char*)p->value, (char*)&w[i],
    p->length * sizeof(ARB_type));
delete w;
}
f (debug&32)	outputarb(cerr, "\toutput=", p->value, p->length);	// DELETE

