* Copyright (c) 1990 by AT&T Bell Telephone Laboratories, Incorporated. */
* The C++ Answer Book */
* Tony Hansen */
* All rights reserved. */
*	@(#)ctype.h	1.4	*/d/*	3.0 SID #	1.2	*/d#ifndef CTYPEH
 define CTYPEH
onst int _U = 01;	/* Upper case */
onst int _L = 02;	/* Lower case */
onst int _N = 04;	/* Numeral (digit) */
onst int _S = 010;	/* Spacing character */
onst int _P = 020;	/* Punctuation */
onst int _C = 040;	/* Control character */
onst int _B = 0100;	/* Blank */
onst int _X = 0200;	/* heXadecimal digit */

xtern char	_ctype[];

nline int isalpha(int c) { return ((_ctype + 1)[c] & (_U | _L)); }
nline int isupper(int c) { return ((_ctype + 1)[c] & _U); }
nline int islower(int c) { return ((_ctype + 1)[c] & _L); }
nline int isdigit(int c) { return ((_ctype + 1)[c] & _N); }
nline int isxdigit(int c) { return ((_ctype + 1)[c] & _X); }
nline int isalnum(int c) { return ((_ctype + 1)[c] & (_U | _L | _N)); }
nline int isspace(int c) { return ((_ctype + 1)[c] & _S); }
nline int ispunct(int c) { return ((_ctype + 1)[c] & _P); }
nline int isprint(int c) { return ((_ctype + 1)[c] & (_P | _U | _L | _N | _B)); }
nline int isgraph(int c) { return ((_ctype + 1)[c] & (_P | _U | _L | _N)); }
nline int iscntrl(int c) { return ((_ctype + 1)[c] & _C); }
nline int isascii(int c) { return (!((c) & ~0177)); }
nline int _toupper(int c) { return ((c) - 'a' + 'A'); }
nline int _tolower(int c) { return ((c) - 'A' + 'a'); }
nline int toascii(int c) { return ((c) & 0177); }
endif /* CTYPEH */
